=== debian/changelog ===
asterisk (1:13.14.1~dfsg-2+deb9u4) stretch-security; urgency=medium

  * AST-2018-004 / CVE-2018-7284: Crash when receiving SUBSCRIBE request
    (Closes: #891227)
  * AST-2018-005 / CVE-2018-7286: Crash when large numbers of TCP connections
    are closed suddenly (Closes: #891228)
  * AST-2018-008 / CVE-2018-12227: PJSIP endpoint presence disclosure when
    using ACL (Closes: #902954)
  * AST-2018-009 / CVE-2018-17281: Remote crash vulnerability in HTTP
    websocket upgrade (Closes: #909554)

 -- Bernhard Schmidt <berni@debian.org>  Sun, 30 Sep 2018 23:24:10 +0200

asterisk (1:13.14.1~dfsg-2+deb9u3) stretch-security; urgency=medium

  [ Tzafrir Cohen ]
  * AST-2017-009: ignored for the record.
  * AST-2017-010 / CVE-2017-16671: Buffer overflow in CDRs (call logs)
    (Closes: #881257)
  * AST-2017-011 / CVE-2017-16672: Memory/File Descriptor/RTP leak in
    pjsip session resource (Closes: #881256)
  * AST-2017-012 / CVE-2017-17664: Remote Crash Vulnerability in RTCP Stack
    (Closes: #884345)
  * AST-2017-013 / CVE-2017-17090: DoS (memory leak) in chan_skinny
    (Closes: #883342)
  * ASTERISK-26606.patch: fix openssl error reporting (Closes: #883767)
  * debian/.gitignore: typo
  * gbp.conf: set branch name

  [ Bernhard Schmidt ]
  * Drop duplicate filter line from d/gbp.conf

 -- Tzafrir Cohen <tzafrir@debian.org>  Fri, 29 Dec 2017 16:27:08 +0200

asterisk (1:13.14.1~dfsg-2+deb9u2) stretch-security; urgency=high

  * CVE-2017-14603 / AST-2017-008
    This is a follow-up for AST-2017-005: RTP/RTCP information leak
    improving robustness of the security fix and fixing a regression
    with re-INVITEs (Closes: #876328)
  * Fix one-way audio with chan_sip when transcoding (Closes: #875450)

 -- Bernhard Schmidt <berni@debian.org>  Sat, 23 Sep 2017 21:26:19 +0200

asterisk (1:13.14.1~dfsg-2+deb9u1) stretch-security; urgency=high

  * CVE-2017-14099 / AST-2017-005
    Media takeover in RTP stack ("RTP bleed") (Closes: #873907)
  * CVE-2017-14100 / AST-2017-006
    Shell access command injection in app_minivm (Closes: #873908)

 -- Bernhard Schmidt <berni@debian.org>  Sat, 02 Sep 2017 23:21:14 +0200

asterisk (1:13.14.1~dfsg-2) unstable; urgency=high

  [ Tzafrir Cohen ]
  * CVE-2017-9358 / AST-2017-004: Memory exhaustion on short SCCP packets
    (Closes: #863906)
  * Documentation updates in debian/:
    - d/p/test_framework.patch: no longer an upstream issue
    - d/asterisk-config-custom:
      - fix typo: buildbuildpackage (Closes: #860902)
      - add comment that dpkg-buildpackage comes from dpkg-dev

 -- Bernhard Schmidt <berni@debian.org>  Fri, 02 Jun 2017 14:40:15 +0200

asterisk (1:13.14.1~dfsg-1) unstable; urgency=medium

  * New upstream version 13.14.1
    - Fixes AST-2017-001 (Buffer overflow in CDR's set user) (Closes: #859910)
  * Import upstream fix to set the RTP source address to the address bound by
    the PJSIP transport (Closes: #859911)

 -- Bernhard Schmidt <berni@debian.org>  Mon, 10 Apr 2017 12:53:03 +0200
